`timescale 1ns/1ns
`define clk_period 40

module RAM_tb;

    xsGSR xsGSR_INST(.GSR(1'b1));
    xsPWR xsPWR_INST(.PUR(1'b1));

	reg clk;
	reg Reset;
	reg [15:0]Data;
	reg [8:0]RdAddress;
	reg [8:0]WrAddress;
	reg WrClockEn;
	reg WE;
	reg RdClockEn;
	
	wire [15:0]Q;
	
	integer i;
	
	
	EBR_PDP EBR_PDP(
		.WrAddress(WrAddress), 
		.RdAddress(RdAddress), 
		.Data(Data), 
		.WE(WE),
		.RdClock(clk),
		.RdClockEn(RdClockEn),
		.Reset(Reset),
		.WrClock(clk),
		.WrClockEn(WrClockEn),
		.Q(Q)
	);
	
	initial clk = 1;
	always#(`clk_period/2)clk = ~clk;
	
	initial begin
		Reset = 1;
		Data = 0;
		RdAddress = 0;
		WrAddress = 0;
		WrClockEn = 0;
		WE = 0;
		RdClockEn =0;
		Reset = 0;
		#401
		for (i=0;i<=15;i=i+1)begin
			WrClockEn = 1;
			WE = 1;
			Data = 256 - i;
			WrAddress = i;
			#`clk_period;
		end
		WrClockEn = 0;
		WE = 0;
		#(`clk_period*10);
		for (i=0;i<=15;i=i+1)begin
			RdClockEn = 1;
			RdAddress = i;
			#`clk_period;
		end
		RdClockEn = 0;
		#(`clk_period*20);
		$stop;	
	end

endmodule
